# HeiGIT ohsome platform

This is the parent [_pom_ file](https://maven.apache.org/pom.html) of the [ohsome platform](https://www.ohsome.org/). It defines the topmost properties of all subprojects like the [OSHDB](https://github.com/GIScience/oshdb) or the [ohsome API](https://github.com/GIScience/ohsome-api).

It stores a general [.gitignore](.gitignore), [Jenkinsfile](Jenkinsfile.template) and [checkstyle rules](ohsome-codestyle/src/main/resources/checkstyle-google-ohsome.xml), to be used by all java/maven projects within the ohsome platform.

## Updating parent

Currently, the parent is used in the following projects, which should use a new parent:
 * **Stable packages**
    * [ohsome parent](https://gitlab.gistools.geog.uni-heidelberg.de/giscience/big-data/ohsome/parent)
    * [OSHDB](https://github.com/giscience/oshdb)
    * [ohsome API](https://github.com/giscience/ohsome-api)
 * **Stable tools**
    * [OSHDB benchmarks](https://gitlab.gistools.geog.uni-heidelberg.de/giscience/big-data/ohsome/oshdb-benchmarks)
    * [OSHDB examples](https://gitlab.gistools.geog.uni-heidelberg.de/giscience/big-data/ohsome/oshdb-examples)
 * **Experimental tools and libs**
    * [changeset metadata](https://gitlab.gistools.geog.uni-heidelberg.de/giscience/big-data/ohsome/libs/changeset-metadata)
    * [OSHDB database driver](https://gitlab.gistools.geog.uni-heidelberg.de/giscience/big-data/ohsome/helpers/oshdb-database-driver)
    * [OSHDB extract generator](https://gitlab.gistools.geog.uni-heidelberg.de/giscience/big-data/ohsome/helpers/oshdb-extractor)
    * [OSHDB fill ignite caches](https://gitlab.gistools.geog.uni-heidelberg.de/giscience/big-data/ohsome/helpers/oshdb-fill-ignite-caches)
    * [username resolver](https://gitlab.gistools.geog.uni-heidelberg.de/giscience/big-data/ohsome/libs/username-resolver)
 * **Archived libs**
    * _[ohsome filter](https://gitlab.gistools.geog.uni-heidelberg.de/giscience/big-data/ohsome/libs/ohsome-filter) ([integrated into the OSHDB](https://github.com/GIScience/oshdb/pull/306))_

Please do **not** forget to update the [.idea/checkstyle-idea.xml](.idea/checkstyle-idea.xml) file when updating the ohsome parent in the projets!

## Updating Jenkinsfile

If the general Jenkinsfile ([Jenkinsfile.template](Jenkinsfile.template)) is updated, you can use a script to diff all the Jenkinsfiles. The script is still WIP and experimental. Please don't forget to commit and form a MR/PR for the changed Jenkinsfile.

Script example:
```bash
cd /path/to/repos/basedir/ohsome-parent
./diff-jenkinsfiles.sh </path/to/repos/basedir> <fix-branchname>
```
